/*
 *      a s t e s t
 *
 *  Test program for the *= and /= support routines
 *  when LHS is an 'int' typem and RHS is FP type.
 */
#include <stdio.h>

void  print_result (char * str, int actual, int expected)
{
    printf ("%s.  Result=%d      ", str, actual);
    if (actual == expected)
        printf ("OK");
    else 
        printf ("**** ERROR ****");
    printf ("\n");
    return;
}

main()
{
    double d;
    float f;

    char c;
    short s;
    int i;
    long l;

    unsigned char uc;
    unsigned short us;
    unsigned int ui;
    unsigned long ul;

    static int   x[12] = {0,1,2,3,4,5,6,7,8,9,10,11};
    int x_9 = 9;
    float Pf[12];

    struct {
        int s:16;
        unsigned int u:16;
    } b;

    printf ("Test of 'asmul', 'asdiv' and 'asop' support routines\n\n");

    c = 32;   Pf[x[x_9]] = 14;   c /= Pf[x[x_9]];
    print_result ("c /= Pf[x[x_9]]", c, 2);


    /*
     *   Positive =* positive
     */
    d = 1.2;

    c = 10;    c *= d;
    print_result ("c(=10) *= 1.2", c, 12);

    s = 10;    s *= d;
    print_result ("s(=10) *= 1.2", s, 12);

    i = 10;    i *= d;
    print_result ("i(=10) *= 1.2", i, 12);

    l = 10;    l *= d;
    print_result ("l(=10) *= 1.2", l, 12);

    b.s = 10;    b.s *= d;
    print_result ("b.s(=10) *= 1.2", b.s, 12);

    uc = 10;    uc *= d;
    print_result ("uc(=10) *= 1.2", uc, 12);

    us = 10;    us *= d;
    print_result ("us(=10) *= 1.2", us, 12);

    ui = 10;    ui *= d;
    print_result ("ui(=10) *= 1.2", ui, 12);

    ul = 10;    ul *= d;
    print_result ("ul(=10) *= 1.2", ul, 12);

    b.u = 10;    b.u *= d;
    print_result ("b.u(=10) *= 1.2", b.u, 12);

    printf ("\nPress a key to continue\n\n");
    getchar();

    /*
     *   Positive =* negative
     */
    d = -1.2;

    c = 10;    c *= d;
    print_result ("c(=10) *= -1.2", c, -12);

    s = 10;    s *= d;
    print_result ("s(=10) *= -1.2", s, -12);

    i = 10;    i *= d;
    print_result ("i(=10) *= -1.2", i, -12);

    l = 10;    l *= d;
    print_result ("l(=10) *= -1.2", l, -12);

    b.s = 10;    b.s *= d;
    print_result ("b.s(=10) *= -1.2", b.s, -12);

    uc = 10;    uc *= d;
    print_result ("uc(=10) *= -1.2", uc, ((unsigned char)-12));

    us = 10;    us *= d;
    print_result ("us(=10) *= -1.2", us, ((unsigned short)-12));

    ui = 10;    ui *= d;
    print_result ("ui(=10) *= -1.2", ui, ((unsigned int)-12));

    ul = 10;    ul *= d;
    print_result ("ul(=10) *= -1.2", ul, ((unsigned long)-12));

    b.u = 10;    b.u *= d;
    print_result ("b.u(=10) *= -1.2", b.u, ((unsigned short)-12));

    printf ("\nPress a key to continue\n\n");
    getchar();
    /*
     *   Positive /* positive
     */
    d = 1.2;

    c = 10;    c /= d;
    print_result ("c(=10) /= 1.2", c, 8);
    c = 10;    c /= d;
    print_result ("c(=10) /= 1.2", c /= d, 8);

    s = 10;    s /= d;
    print_result ("s(=10) /*= 1.2", s, 8);

    i = 10;    i /= d;
    print_result ("i(=10) /= 1.2", i, 8);

    l = 10;    l /= d;
    print_result ("l(=10) /= 1.2", l, 8);

    b.s = 10;    b.s /= d;
    print_result ("b.s(=10) /= 1.2", b.s, 8);

    uc = 10;    uc /= d;
    print_result ("uc(=10) /= 1.2", uc, 8);

    us = 10;    us /= d;
    print_result ("us(=10) /= 1.2", us, 8);

    ui = 10;    ui /= d;
    print_result ("ui(=10) /= 1.2", ui, 8);

    ul = 10;    ul /= d;
    print_result ("ul(=10) /= 1.2", ul, 8);

    b.u = 10;    b.u /= d;
    print_result ("b.u(=10) /= 1.2", b.u, 8);

    printf ("\nPress a key to continue\n\n");
    getchar();
    /*
     *   Positive /= negative
     */
    d = -1.2;

    c = 10;    c /= d;
    print_result ("c(=10) /= -1.2", c, -8);

    s = 10;    s /= d;
    print_result ("s(=10) /= -1.2", s, -8);

    i = 10;    i /= d;
    print_result ("i(=10) /= -1.2", i, -8);

    l = 10;    l /= d;
    print_result ("l(=10) /= -1.2", l, -8);

    b.s = 10;    b.s /= d;
    print_result ("b.s(=10) /= -1.2", b.s, -8);

    uc = 10;    uc /= d;
    print_result ("uc(=10) /= -1.2", uc, ((unsigned char)-8));

    us = 10;    us /= d;
    print_result ("us(=10) /= -1.2", us, ((unsigned short)-8));

    ui = 10;    ui /= d;
    print_result ("ui(=10) /= -1.2", ui, ((unsigned int)-8));

    ul = 10;    ul /= d;
    print_result ("ul(=10) /= -1.2", ul, ((unsigned long)-8));

    b.u = 10;    b.u /= d;
    print_result ("b.u(=10) /= -1.2", b.u, ((unsigned short)-8));


    printf ("\n");
}

