/*
 * C compiler
 * ==========
 *
 * Copyright 1989, 1990, 1991 Christoph van Wuellen.
 * Credits to Matthew Brandt.
 * All commercial rights reserved.
 *
 * This compiler may be redistributed as long there is no
 * commercial interest. The compiler must not be redistributed
 * without its full sources. This notice must stay intact.
 *
 * History:
 *
 * 1989   starting an 68000 C compiler, starting with material
 *        originally by M. Brandt
 * 1990   68000 C compiler further bug fixes
 *        started i386 port (December)
 * 1991   i386 port finished (January)
 *        further corrections in the front end and in the 68000
 *        code generator.
 *        The next port will be a SPARC port
 */

#ifndef _GEN386_H
#define _GEN386_H

#include "genx86.h"

/*
 * perhaps not necessary, but useful: 32-bit alignment for 32-bit types
 */
#define	AL_ILLEGAL	((SIZE) 1)
#define AL_CHAR 	((SIZE) 1)
#define AL_SHORT	((SIZE) 2)
#define AL_LONG 	((SIZE) 4)
#define AL_POINTER	((SIZE) 4)
#define AL_FLOAT	((SIZE) 4)
#define AL_DOUBLE	((SIZE) 4)
#define	AL_LONGDOUBLE	((SIZE) 4)
#define AL_STRUCT	((SIZE) 4)
#define AL_FUNC		((SIZE) 4)

#define AL_DEFAULT	((SIZE) 4)	/* alignment suitable for all types */

/* support routines */
#define	SUP_FPADD	(CHAR *)".fpadd"
#define	SUP_FPCMP	(CHAR *)".fpcmp"
#define	SUP_FPDIV	(CHAR *)".fpdiv"
#define	SUP_FPDIVR	(CHAR *)".fpdivr"
#define	SUP_FPFADD	(CHAR *)".fpfadd"
#define	SUP_FPFDIVR	(CHAR *)".fpfdivr"
#define	SUP_FPFMULT	(CHAR *)".fpfmult"
#define	SUP_FPFSUBR	(CHAR *)".fpfsubr"
#define	SUP_FPGETSTK386	(CHAR *)".fpgetstk386"
#define	SUP_FPGETSTK387	(CHAR *)".fpgetstk387"
#define	SUP_FPLDI	(CHAR *)".fpldi"
#define	SUP_FPLDL	(CHAR *)".fpldl"
#define	SUP_FPLDS	(CHAR *)".fplds"
#define	SUP_FPLDU	(CHAR *)".fpdlu"
#define	SUP_FPLADD	(CHAR *)".fpladd"
#define	SUP_FPLDIVR	(CHAR *)".fpldivr"
#define	SUP_FPLMULT	(CHAR *)".fplmult"
#define	SUP_FPLSUBR	(CHAR *)".fplsubr"
#define	SUP_FPMULT	(CHAR *)".fpmult"
#define	SUP_FPNEG	(CHAR *)".fpneg"
#define	SUP_FPPOP	(CHAR *)".fppop"
#define	SUP_FPPUTSTK386	(CHAR *)".fpputstk386"
#define	SUP_FPPUTSTK387	(CHAR *)".fpputstk387"
#define	SUP_FPSTI	(CHAR *)".fpsti"
#define	SUP_FPSTL	(CHAR *)".fpstl"
#define	SUP_FPSTPL	(CHAR *)".fpstpl"
#define	SUP_FPSTPS	(CHAR *)".fpstps"
#define	SUP_FPSTS	(CHAR *)".fpsts"
#define	SUP_FPSTU	(CHAR *)".fpstu"
#define	SUP_FPSUB	(CHAR *)".fpsub"
#define	SUP_FPSUBR	(CHAR *)".fpsubr"
#define	SUP_FPTST	(CHAR *)".fptst"
#define	SUP__FLDI	(CHAR *)"._fldi"
#define	SUP__FLDU	(CHAR *)"._fldu"
#define	SUP__FSTI	(CHAR *)"._fsti"
#define	SUP__FSTU	(CHAR *)"._fstu"
#define	SUP_STACKCHECK	(CHAR *)".stackcheck"

#endif /* _GEN386_H */
