/*
 *      p r o t o . h
 *
 *  This file contains all prototypes for the jas/as68 program
 */
#ifdef GENERIC

#define VOID int
#define PRIVATE

#else

#define VOID void
#define PRIVATE static

#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

#include <string.h>
#ifndef MEM_DEBUG
#include <stdlib.h>
#endif /* MEM_DEBUG */
#include <unistd.h>

/* cbuf_c */
int bufhead P_((void));
CBUF *cget P_((int seg));
CBUF *generate P_((int n, int act, long val, SYM *psym));
VOID zeros P_((long n));
/* cpy_c */
VOID translate P_((int, int));
VOID addrel P_((int));
VOID dumprel P_((void));
VOID chkvalue P_((CBUF *));
/* cross_c */
#ifdef UNIXHOST
int pcrossw P_((int, char *));
int pcrossl P_((long, char *));
char *mklowbyte P_((long));
char *mklowshort P_((long));
char *mklowlong P_((long));
int swapw P_((char *, int));
int swapl P_((char *, int));
char *fixsym P_((struct sym *));
#endif /* UNIXHOST */
/* gen_c */
VOID geninst P_((STMT *sp));
VOID findinst P_((STMT *sp));
int inst_ok P_((STMT *sp));
/* hdr_c */
int headers P_((void));
/* lex_c */
int yyinit P_((void));
int yyprocess P_((int c));
int yymodify P_((char *buf));
/* main_c */
int main P_((int argc, char *argv[]));
int setflags P_((int ac, char *av[]));
int error P_((int n, char *s));
int warn P_((int n, char *s));
char *allocate P_((unsigned size));
char *myreallocate P_((char *ptr, unsigned size));
int output P_((char *buffer, int size, int nitems));
#ifdef QDOS
void output2fb P_((char *buffer, int size, int nitems));
#endif /* QDOS */
#ifdef MEM_DEBUG
int my_free P_((char *x));
#endif /* MEM_DEBUG */
/* mess_c */
VOID geninst P_((STMT *sp));
/* ops_c */
INST *ifind P_((char *token, short *misc));
int icmpare P_((char *token, char *mnemon, short *misc));
int chk_cond P_((char *tp, int all, short *misc));
/* opt_c */
VOID add_brnch P_((CBUF *cptr, long where));
int do_opt P_((void));
/* parse_c */
int yyparse P_((void));
int Ylabel_list P_((void));
LIST *Yname_list P_((void));
LIST *Yexpr_list P_((void));
LIST *make_slist P_((LIST **last, char *string));
OPERAND *Yoperand P_((void));
EXPR Yexpr P_((void));
EXPR Xexpr P_((void));
EXPR Aexpr P_((void));
EXPR Sexpr P_((void));
EXPR Pexpr P_((void));
EXPR Mexpr P_((void));
EXPR Uexpr P_((void));
EXPR Yfactor P_((void));
VOID Yerror P_((char *s));
VOID Yinstruction P_((void));
VOID Yline P_((void));
VOID Ystatement P_((void));
/* pass_c */
int aspass1 P_((void));
int chsegmt P_((int segment));
/* scan_c */
int getnext P_((void));
int yygetc P_((void));
int yyungetc P_((int c));
int yylex P_((void));
long getnum P_((char *s));
/* sym_c */
int cmpname P_((SYM *p, char *name));
SYM *newsym P_((void));
SYM *lookup P_((char *name));
int hash P_((char *name));
VOID cpyname P_((char dst[8], SYM *p));
VOID dumpsym P_((void));
VOID fixsymval P_((long addr, long incr, int segmt));
VOID flexsym P_((void));
VOID putsym P_((SYM *p));
VOID setindex P_((SYM *p));
VOID setname P_((SYM *p, char *name));
VOID symindex P_((void));
VOID symwalk P_((int acc, VOID (*fun)()));

#undef P_

#endif /* GENERIC */

